diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/service/devicemanager/DeviceList.java AndroidSource/frameworks/base/core/java/android/service/devicemanager/DeviceList.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/service/devicemanager/DeviceList.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/core/java/android/service/devicemanager/DeviceList.java	2016-01-11 19:31:35.000000000 +0900
@@ -0,0 +1,18 @@
+package android.service.devicemanager;
+
+import java.util.HashMap;
+
+public class DeviceList 
+{
+	private static HashMap<String, Device> devices = new HashMap<String, Device>();
+
+    public static HashMap<String, Device> getDevices() {
+		return devices;
+	}
+
+	public static void setDevices(HashMap<String, Device> devices) {
+		DeviceList.devices = devices;
+	}
+	
+
+}
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/service/devicemanager/DeviceManager.java AndroidSource/frameworks/base/core/java/android/service/devicemanager/DeviceManager.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/service/devicemanager/DeviceManager.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/core/java/android/service/devicemanager/DeviceManager.java	2016-06-22 11:31:03.000000000 +0900
@@ -0,0 +1,125 @@
+package android.service.devicemanager;
+
+import java.util.List;
+
+import android.content.Context;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.service.remote.IRemoteService;
+import android.util.Log;
+
+public class DeviceManager {
+	private final IDeviceManager mService;
+
+	public DeviceManager(IDeviceManager service) {
+		mService = service;
+	}
+	
+	public DeviceManager(Context ctx) {
+		mService = IDeviceManager.Stub.asInterface(ServiceManager.getService(Context.DEVICE_MANAGEMENT_SERVICE));
+	}
+	
+	public DeviceManager() {
+		mService = IDeviceManager.Stub.asInterface(ServiceManager.getService(Context.DEVICE_MANAGEMENT_SERVICE));
+	}
+
+	public String recommendDevice(List<Device> peerlist) {
+		try {
+			return mService.recommendDevice(peerlist);
+		} catch (RemoteException e) {
+            e.printStackTrace();
+		}
+		return null;
+
+	}
+
+	public String[] getSystemServiceOnServerList(){
+	    try{
+	        return mService.getSystemServiceOnServerList();
+	    } catch(RemoteException e){
+	        e.printStackTrace();
+	    }
+	    return null;
+	}
+	
+	public String[] getTaskExecutorOnServerList(){
+        try{
+            return mService.getTaskExecutorOnServerList();
+        } catch(RemoteException e){
+            e.printStackTrace();
+        }
+        return null;
+    }
+	
+	public List<Device> getDeviceList(int kind) {
+		try {
+			return mService.getDeviceList(kind);
+		} catch (RemoteException e) {
+		    e.printStackTrace();
+		}
+		return null;
+
+	}
+	
+	public void constructCluster(List<Device> devicelist)
+	{
+		try
+		{
+			Log.d("DeviceManager", "in construct!");
+			mService.constructCluster(devicelist);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+	}
+	
+	public int getNumofConfiguredDevices()
+	{
+		try
+		{
+			return mService.getNumofConfiguredDevices();
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+		return 0;
+	}
+	
+    public Device getDevice(String name)
+    {
+		try
+		{
+			return mService.getDevice(name);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+		return null;
+	}
+    
+    public void askResources(List<Device> devicelist) {
+    	try
+		{
+			mService.askResources(devicelist);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+    }
+    
+    public void allowResources(String deviceName, int[] allowedResources)
+    {
+    	try
+		{
+			mService.allowResources(deviceName, allowedResources);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+    }
+}
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/service/devicemanager/IDeviceManager.aidl AndroidSource/frameworks/base/core/java/android/service/devicemanager/IDeviceManager.aidl
--- Original_4.4.4_r1/frameworks/base/core/java/android/service/devicemanager/IDeviceManager.aidl	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/core/java/android/service/devicemanager/IDeviceManager.aidl	2016-06-23 18:38:57.000000000 +0900
@@ -0,0 +1,21 @@
+package android.service.devicemanager;
+
+import android.service.devicemanager.Device;
+
+interface IDeviceManager {
+	void initDevices();
+	String recommendDevice(in List<Device> devicelist); 
+	List<Device> getDeviceList(int kind);
+	String[] getSystemServiceOnServerList();
+	String[] getTaskExecutorOnServerList();
+	
+	int getNumofConfiguredDevices();
+    Device getDevice(String name);
+    void constructCluster(in List<Device> devicelist);
+    
+    void askResources(in List<Device> devicelist);
+    void allowResources(String deviceName, in int[] allowedResources);
+    void showRequestDialog(String deviceName, String deviceIP, in int[] askedResources);
+	
+	boolean isAllowedForResource(String device, int resource);
+}
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/service/distribute/IDistributedComputingService.aidl AndroidSource/frameworks/base/core/java/android/service/distribute/IDistributedComputingService.aidl
--- Original_4.4.4_r1/frameworks/base/core/java/android/service/distribute/IDistributedComputingService.aidl	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/core/java/android/service/distribute/IDistributedComputingService.aidl	2015-01-27 21:56:54.000000000 +0900
@@ -0,0 +1,14 @@
+package android.service.distribute;
+
+interface IDistributedComputingService
+{
+	void startJobManager(String ip);
+	void stopJobManager();
+	
+	void startTaskExecutor();
+	void stopTaskExecutor();
+	
+	int sum(int start, int end);
+	
+	void testOperation();
+}
\ No newline at end of file
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/service/remote/IRemoteService.aidl AndroidSource/frameworks/base/core/java/android/service/remote/IRemoteService.aidl
--- Original_4.4.4_r1/frameworks/base/core/java/android/service/remote/IRemoteService.aidl	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/core/java/android/service/remote/IRemoteService.aidl	2016-09-26 17:18:41.927817867 +0900
@@ -0,0 +1,80 @@
+package android.service.remote;
+
+import android.service.remote.RemoteRequest;
+
+import android.service.devicemanager.Device;
+
+import android.service.collaboroid.IGeneralMessageListener;
+
+import android.view.MotionEvent;
+import android.view.KeyEvent;
+import android.location.Location;
+
+
+interface IRemoteService
+{
+	boolean startServer();
+	boolean stopServer();
+	
+	void setConfiguration();
+	void setEnabled(boolean isEnabled);
+	
+	boolean isServerOn();
+	
+//	void connectToServer();
+	boolean connectToServer(String ip);
+	void disconnectToServer();
+	void initConnections();
+	List<String> getClientIPs();
+	List<String> getServerIPs();
+	void printServerIPs();
+	void sendAllMusic(int sampleSize, in byte[] to_send, long presentationTime);
+	void sendAllrequest(in RemoteRequest request);
+	
+	boolean sendResourceRequests(in List<Device> requestDeviceList);
+	boolean isAllowedForResource(String deviceName, String deviceIP, in int[] resources);
+	boolean respondAllowedResources(String deviceIP, in int[] resources);
+	
+	boolean sendRequest(in RemoteRequest request);
+//	void sendSensorRequest(in SensorEventQueue2 queue);
+	void sendAllrequestVib(in RemoteRequest request);
+
+	// for MotionEvent
+	void sendMotionEvent(in MotionEvent event);
+	
+	// for KeyEvent
+	void sendKeyEvent(in KeyEvent event);
+	
+	// for SensorEvent
+//	boolean setRemoteSensorOn(boolean flag, SensorEventListener listener);
+	void addSensorHandle(int type, int handle);
+	void removeSensorHandle(int type);
+	void sendSensorEvent(int type, int sensor, in float[] values, int accuracy, long timestamp);
+	
+	// for API
+	void playMusic();
+	
+	// for evaluations
+	void testOperation();
+	void testVibrate();
+	void testMusic();
+	void testVideo();
+	void testTouch();
+	void testKey();
+	void testSensor();
+	void testLocation();
+	void requestMotionEvents();
+	void launchDummyApp();	
+
+	void sendMusicData(int sampleSize, in byte[] to_send, long presentationTime);
+	
+	int getVideoPlayers();
+	void sendVideoSignal(int vport);
+	
+	void sendLocation(in Location location);
+	
+//	Object sendRountTripRequest(in RemoteRequest request);
+
+	void registerListener(IGeneralMessageListener listener);
+	void unregisterListener(IGeneralMessageListener listener);
+}
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/service/remote/RemoteRequest.aidl AndroidSource/frameworks/base/core/java/android/service/remote/RemoteRequest.aidl
--- Original_4.4.4_r1/frameworks/base/core/java/android/service/remote/RemoteRequest.aidl	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/core/java/android/service/remote/RemoteRequest.aidl	2014-12-27 02:19:52.000000000 +0900
@@ -0,0 +1,3 @@
+package android.service.remote;
+
+parcelable RemoteRequest;
\ No newline at end of file
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/service/remote/SdPackage.java AndroidSource/frameworks/base/core/java/android/service/remote/SdPackage.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/service/remote/SdPackage.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/core/java/android/service/remote/SdPackage.java	2015-10-27 11:41:12.000000000 +0900
@@ -0,0 +1,79 @@
+package android.service.remote;
+
+import java.io.Serializable;
+
+
+
+public class SdPackage implements Serializable{
+
+	private int sampleSize = 0;
+	private byte[] sampleData;
+	private long presentationTime = 0;
+	private String mime = "audio/mpeg";
+	private int bitrate = 0;
+	private int channels = 0;
+	private int sampleRate = 0;
+	private long duration = 0;
+	private byte[] csd0;
+	/**
+	 * 
+	 */
+	private static final long serialVersionUID = 1L;
+	
+	public SdPackage(int sampleSize, byte[] sampleData, long presentationTime){
+		this.sampleSize = sampleSize;
+		this.sampleData = sampleData;
+		this.presentationTime = presentationTime; 
+	}
+	
+	public SdPackage(String _mime, int _bitrate, int _channels, int _sampleRate, long _duration, byte[] _csd0){
+		this.mime = _mime;
+		this.bitrate = _bitrate;
+		this.channels = _channels;
+		this.sampleRate = _sampleRate;
+		this.duration = _duration;
+		this.csd0 = _csd0;
+	}
+	
+	public String getMime(){
+		return this.mime;
+	}
+	
+	public int getBitrate(){
+		return this.bitrate;
+	}
+	
+	public int getChannels(){
+		return this.channels;
+	}
+	
+	public int getSampleRate(){
+		return this.sampleRate;
+	}
+
+	public int getSampleSize(){
+		return this.sampleSize;
+	}
+	
+	public long getDuration(){
+		return this.duration;
+	}
+	
+	public byte[] get_csd0(){
+		return this.csd0;
+	}
+	
+	public byte[] getSampleData(){
+		return this.sampleData;
+	}
+	
+	public long getPresentationTime(){
+		return this.presentationTime;
+	}
+	
+	@Override
+	public String toString(){
+		 return this.sampleSize+" is sampleSize,  " + this.sampleData + " is sampleData,  " + this.presentationTime + " is prest. time"; 
+	}
+	
+}
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/service/remote/vData.java AndroidSource/frameworks/base/core/java/android/service/remote/vData.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/service/remote/vData.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/core/java/android/service/remote/vData.java	2015-10-27 11:41:12.000000000 +0900
@@ -0,0 +1,112 @@
+package android.service.remote;
+
+import java.io.Serializable;
+
+import android.os.Parcel;
+import android.os.Parcelable;
+
+public class vData implements Serializable{
+
+	private String mime = "video/avc";
+	private int width = 0;
+	private int height = 0;
+	private byte[] csd0 = null;
+	private byte[] csd1 = null;
+	
+	public int sampleSize = 0;
+	public byte[] sampleData;
+	public long presentationTime = 0;
+	
+	private static final long serialVersionUID = 1L;
+	
+	/**
+	 * 
+	 */
+	public vData(){
+		
+	}
+	
+	/**
+	 * 
+	 */
+	public vData(int _sampleSize, byte[] _sampleData, long _presentationTime){
+		sampleSize = _sampleSize;
+		sampleData = _sampleData;
+		presentationTime = _presentationTime;
+	}
+	
+	
+	/**
+	 * 
+	 */
+	public void setMediaFormat(String _mime, int _width, int _height, byte[] _csd0, byte[] _csd1){
+		mime = _mime;
+		width = _width;
+		height = _height;
+		csd0 = _csd0;
+		csd1 = _csd1;
+	}
+
+	/**
+	 * 
+	 */
+	public int getSampleSize(){
+		return sampleSize;
+	}
+
+	/**
+	 * 
+	 */
+	public byte[] getSampleData(){
+		return sampleData;
+	}
+
+	/**
+	 * 
+	 */
+	public long getPresentationTime(){
+		return presentationTime;
+	}	
+	/**
+	 * 
+	 */
+	public String getMime(){
+		return mime;
+	}
+	
+	/**
+	 * 
+	 */
+	public int getWidth(){
+		return width;
+	}
+	
+	/**
+	 * 
+	 */
+	public int getHeight(){
+		return height;
+	}
+
+	/**
+	 * 
+	 */
+	public byte[] get_csd0(){
+		return csd0;
+	}
+
+	/**
+	 * 
+	 */
+	public byte[] get_csd1(){
+		return csd1;
+	}
+
+	
+	@Override
+	public String toString() {
+		return sampleSize + " is sampleSize,  " + sampleData
+				+ " is sampleData,  " + presentationTime + " is prest. time";
+	}
+	
+}
diff -urN Original_4.4.4_r1/frameworks/base/core/java/android/view/MotionEvent.java AndroidSource/frameworks/base/core/java/android/view/MotionEvent.java
--- Original_4.4.4_r1/frameworks/base/core/java/android/view/MotionEvent.java	2016-01-29 15:12:27.459488000 +0900
+++ AndroidSource/frameworks/base/core/java/android/view/MotionEvent.java	2015-12-07 16:52:20.000000000 +0900
@@ -20,6 +20,7 @@
 import android.os.Parcel;
 import android.os.Parcelable;
 import android.os.SystemClock;
+import android.util.Log;
 import android.util.SparseArray;
 
 /**
@@ -321,6 +322,14 @@
      */
     public static final int ACTION_POINTER_INDEX_SHIFT = 8;
 
+    // ADDED BY JH
+    public static final int SOURCE_DEVICE_MASK = 0xff000000;
+    public static final int SOURCE_DEVICE_SHIFT = 24;
+    public static final int ACTION_POINTER_MASK = 0xffff;
+    // ADDED BY JH
+    
+    
+    
     /**
      * @deprecated Use {@link #ACTION_POINTER_INDEX_MASK} to retrieve the
      * data index associated with {@link #ACTION_POINTER_DOWN}.
@@ -1314,6 +1323,9 @@
     private int mNativePtr;
 
     private MotionEvent mNext;
+    
+    // ADDED BY JH
+    private int mTest;
 
     private static native int nativeInitialize(int nativePtr,
             int deviceId, int source, int action, int flags, int edgeFlags,
@@ -1321,6 +1333,15 @@
             float xOffset, float yOffset, float xPrecision, float yPrecision,
             long downTimeNanos, long eventTimeNanos,
             int pointerCount, PointerProperties[] pointerIds, PointerCoords[] pointerCoords);
+    
+    // ADDED BY JH
+    /*private static native int nativeInitialize(int nativePtr,
+            int deviceId, int source, int sourceDevice, int action, int flags, int edgeFlags,
+            int metaState, int buttonState,
+            float xOffset, float yOffset, float xPrecision, float yPrecision,
+            long downTimeNanos, long eventTimeNanos,
+            int pointerCount, PointerProperties[] pointerIds, PointerCoords[] pointerCoords);*/
+    
     private static native int nativeCopy(int destNativePtr, int sourceNativePtr,
             boolean keepHistory);
     private static native void nativeDispose(int nativePtr);
@@ -1368,6 +1389,10 @@
 
     private static native int nativeReadFromParcel(int nativePtr, Parcel parcel);
     private static native void nativeWriteToParcel(int nativePtr, Parcel parcel);
+    
+    // ADDED BY JH
+    //private static native void nativeSetSourceDevice(int nativePtr, int sourceDevice);
+    //private static native int nativeGetSourceDevice(int nativePtr);
 
     private MotionEvent() {
     }
@@ -1434,7 +1459,9 @@
             int edgeFlags, int source, int flags) {
         MotionEvent ev = obtain();
         ev.mNativePtr = nativeInitialize(ev.mNativePtr,
-                deviceId, source, action, flags, edgeFlags, metaState, buttonState,
+                deviceId, source,
+                //0, 
+                action, flags, edgeFlags, metaState, buttonState,
                 0, 0, xPrecision, yPrecision,
                 downTime * NS_PER_MS, eventTime * NS_PER_MS,
                 pointerCount, pointerProperties, pointerCoords);
@@ -1535,14 +1562,16 @@
             pc[0].size = size;
 
             ev.mNativePtr = nativeInitialize(ev.mNativePtr,
-                    deviceId, InputDevice.SOURCE_UNKNOWN, action, 0, edgeFlags, metaState, 0,
+                    deviceId, InputDevice.SOURCE_UNKNOWN, 
+                    //0, 
+                    action, 0, edgeFlags, metaState, 0,
                     0, 0, xPrecision, yPrecision,
                     downTime * NS_PER_MS, eventTime * NS_PER_MS,
                     1, pp, pc);
             return ev;
         }
     }
-
+    
     /**
      * Create a new MotionEvent, filling in all of the basic values that
      * define the motion.
@@ -1604,7 +1633,65 @@
         return obtain(downTime, eventTime, action, x, y, 1.0f, 1.0f,
                 metaState, 1.0f, 1.0f, 0, 0);
     }
+    
+    // ADDED BY JH
+    /*static public MotionEvent obtain(long downTime, long eventTime, int action,
+            float x, float y, int metaState, int source, int sourceDevice) {
+    	
+    	MotionEvent ev = obtain();
+    	
+        synchronized (gSharedTempLock) {
+            ensureSharedTempPointerCapacity(1);
+            final PointerProperties[] pp = gSharedTempPointerProperties;
+            pp[0].clear();
+            pp[0].id = 0;
+
+            final PointerCoords pc[] = gSharedTempPointerCoords;
+            pc[0].clear();
+            pc[0].x = x;
+            pc[0].y = y;
+            pc[0].pressure = 1.0f;
+            pc[0].size = 1.0f;
 
+            Log.d("MOTIONEVENT", "sourceDevice: " + sourceDevice);
+            
+            ev.mNativePtr = nativeInitialize(ev.mNativePtr,
+                    0, source, sourceDevice, action, 0, 0, metaState, 0,
+                    0, 0, 1.0f, 1.0f,
+                    downTime * NS_PER_MS, eventTime * NS_PER_MS,
+                    1, pp, pc);
+            
+            return ev;
+        }
+    }*/
+    
+    /*static public MotionEvent obtain(long downTime, long eventTime, int action,
+            float x, float y, int metaState, int source, int test) {
+    	
+    	MotionEvent ev = obtain();
+        synchronized (gSharedTempLock) {
+            ensureSharedTempPointerCapacity(1);
+            final PointerProperties[] pp = gSharedTempPointerProperties;
+            pp[0].clear();
+            pp[0].id = 0;
+
+            final PointerCoords pc[] = gSharedTempPointerCoords;
+            pc[0].clear();
+            pc[0].x = x;
+            pc[0].y = y;
+            pc[0].pressure = 1.0f;
+            pc[0].size = 1.0f;
+
+            ev.mNativePtr = nativeInitialize(ev.mNativePtr,
+                    0, action, source, 10, 0, metaState, 0,
+                    0, 0, 1.0f, 1.0f,
+                    downTime * NS_PER_MS, eventTime * NS_PER_MS,
+                    1, pp, pc);
+            return ev;
+        }
+    }*/
+    // ADDED BY JH
+    
     /**
      * Create a new MotionEvent, copying from an existing one.
      */
@@ -1689,6 +1776,22 @@
     public final void setSource(int source) {
         nativeSetSource(mNativePtr, source);
     }
+    
+    // ADDED BY JH
+    /*public final void setSourceDevice(int sourceDevice) {
+    	Log.d("MOTIONEVENT", "JAVAsourceDevice-set:" + sourceDevice);
+        nativeSetSourceDevice(mNativePtr, sourceDevice);
+    }*/
+    
+    public final int getSourceDevice() {
+        //return nativeGetSourceDevice(mNativePtr);
+        //original
+//    	return (nativeGetAction(mNativePtr) & SOURCE_DEVICE_MASK) >> SOURCE_DEVICE_SHIFT;
+        //original end
+            return (nativeGetMetaState(mNativePtr) & SOURCE_DEVICE_MASK) >> SOURCE_DEVICE_SHIFT;    
+    }
+    
+    // ADDED BY JH
 
     /**
      * Return the kind of action being performed.
@@ -1698,7 +1801,7 @@
      * the combination of {@link #ACTION_POINTER_DOWN} with a shifted pointer index.
      */
     public final int getAction() {
-        return nativeGetAction(mNativePtr);
+        return nativeGetAction(mNativePtr) & ACTION_POINTER_MASK;
     }
 
     /**
@@ -2164,7 +2267,7 @@
      * @see KeyEvent#getMetaState()
      */
     public final int getMetaState() {
-        return nativeGetMetaState(mNativePtr);
+        return nativeGetMetaState(mNativePtr) & 0x00ffffff;
     }
 
     /**
@@ -2866,6 +2969,7 @@
             }
             ev.mNativePtr = nativeInitialize(ev.mNativePtr,
                     nativeGetDeviceId(mNativePtr), nativeGetSource(mNativePtr),
+                    //nativeGetSourceDevice(mNativePtr),
                     nativeGetAction(mNativePtr), nativeGetFlags(mNativePtr),
                     nativeGetEdgeFlags(mNativePtr), nativeGetMetaState(mNativePtr),
                     nativeGetButtonState(mNativePtr),
@@ -2959,6 +3063,7 @@
                 if (h == 0) {
                     ev.mNativePtr = nativeInitialize(ev.mNativePtr,
                             nativeGetDeviceId(mNativePtr), nativeGetSource(mNativePtr),
+                            //nativeGetSourceDevice(mNativePtr),
                             newAction, nativeGetFlags(mNativePtr),
                             nativeGetEdgeFlags(mNativePtr), nativeGetMetaState(mNativePtr),
                             nativeGetButtonState(mNativePtr),
diff -urN Original_4.4.4_r1/frameworks/base/core/jni/android_hardware_SensorManager.cpp AndroidSource/frameworks/base/core/jni/android_hardware_SensorManager.cpp
--- Original_4.4.4_r1/frameworks/base/core/jni/android_hardware_SensorManager.cpp	2016-01-29 15:12:27.507488000 +0900
+++ AndroidSource/frameworks/base/core/jni/android_hardware_SensorManager.cpp	2015-10-19 13:59:58.000000000 +0900
@@ -105,6 +105,7 @@
     return size_t(next) < count ? next : 0;
 }
 
+
 //----------------------------------------------------------------------------
 
 class Receiver : public LooperCallback {
@@ -170,7 +171,8 @@
                                         buffer[i].sensor,
                                         mScratch,
                                         buffer[i].vector.status,
-                                        buffer[i].timestamp);
+                                        buffer[i].timestamp,
+                                        buffer[i].reserved0);
                 }
 
                 if (env->ExceptionCheck()) {
@@ -284,11 +286,10 @@
 
     GET_METHOD_ID(gBaseEventQueueClassInfo.dispatchSensorEvent,
             gBaseEventQueueClassInfo.clazz,
-            "dispatchSensorEvent", "(I[FIJ)V");
+            "dispatchSensorEvent", "(I[FIJI)V");
 
     GET_METHOD_ID(gBaseEventQueueClassInfo.dispatchFlushCompleteEvent,
                   gBaseEventQueueClassInfo.clazz,
                   "dispatchFlushCompleteEvent", "(I)V");
-
     return 0;
 }
diff -urN Original_4.4.4_r1/frameworks/base/core/jni/android_view_InputEventSender.cpp AndroidSource/frameworks/base/core/jni/android_view_InputEventSender.cpp
--- Original_4.4.4_r1/frameworks/base/core/jni/android_view_InputEventSender.cpp	2016-01-29 15:12:27.515488000 +0900
+++ AndroidSource/frameworks/base/core/jni/android_view_InputEventSender.cpp	2015-08-04 09:32:44.000000000 +0900
@@ -134,7 +134,9 @@
     for (size_t i = 0; i <= event->getHistorySize(); i++) {
         publishedSeq = mNextPublishedSeq++;
         status_t status = mInputPublisher.publishMotionEvent(publishedSeq,
-                event->getDeviceId(), event->getSource(), event->getAction(), event->getFlags(),
+                event->getDeviceId(), event->getSource(),
+                //event->getSourceDevice(),
+                event->getAction(), event->getFlags(),
                 event->getEdgeFlags(), event->getMetaState(), event->getButtonState(),
                 event->getXOffset(), event->getYOffset(),
                 event->getXPrecision(), event->getYPrecision(),
diff -urN Original_4.4.4_r1/frameworks/base/core/jni/android_view_MotionEvent.cpp AndroidSource/frameworks/base/core/jni/android_view_MotionEvent.cpp
--- Original_4.4.4_r1/frameworks/base/core/jni/android_view_MotionEvent.cpp	2016-01-29 15:12:27.515488000 +0900
+++ AndroidSource/frameworks/base/core/jni/android_view_MotionEvent.cpp	2015-08-04 09:32:18.000000000 +0900
@@ -386,6 +386,60 @@
     return 0;
 }
 
+// ADDED BY JH
+/*static jint android_view_MotionEvent_nativeInitialize(JNIEnv* env, jclass clazz,
+        jint nativePtr,
+        jint deviceId, jint source, jint sourceDevice, jint action, jint flags, jint edgeFlags,
+        jint metaState, jint buttonState,
+        jfloat xOffset, jfloat yOffset, jfloat xPrecision, jfloat yPrecision,
+        jlong downTimeNanos, jlong eventTimeNanos,
+        jint pointerCount, jobjectArray pointerPropertiesObjArray,
+        jobjectArray pointerCoordsObjArray) {
+    if (!validatePointerCount(env, pointerCount)
+            || !validatePointerPropertiesArray(env, pointerPropertiesObjArray, pointerCount)
+            || !validatePointerCoordsObjArray(env, pointerCoordsObjArray, pointerCount)) {
+        return 0;
+    }
+
+    MotionEvent* event = reinterpret_cast<MotionEvent*>(nativePtr);
+    if (!event) {
+        event = new MotionEvent();
+    }
+
+    PointerProperties pointerProperties[pointerCount];
+    PointerCoords rawPointerCoords[pointerCount];
+
+    for (jint i = 0; i < pointerCount; i++) {
+        jobject pointerPropertiesObj = env->GetObjectArrayElement(pointerPropertiesObjArray, i);
+        if (!pointerPropertiesObj) {
+            goto Error;
+        }
+        pointerPropertiesToNative(env, pointerPropertiesObj, &pointerProperties[i]);
+        env->DeleteLocalRef(pointerPropertiesObj);
+
+        jobject pointerCoordsObj = env->GetObjectArrayElement(pointerCoordsObjArray, i);
+        if (!pointerCoordsObj) {
+            jniThrowNullPointerException(env, "pointerCoords");
+            goto Error;
+        }
+        pointerCoordsToNative(env, pointerCoordsObj, xOffset, yOffset, &rawPointerCoords[i]);
+        env->DeleteLocalRef(pointerCoordsObj);
+    }
+
+    ALOGD("JNI-nativeinit: %d", sourceDevice);
+    event->initialize(deviceId, source, sourceDevice, action, flags, edgeFlags, metaState, buttonState,
+            xOffset, yOffset, xPrecision, yPrecision,
+            downTimeNanos, eventTimeNanos, pointerCount, pointerProperties, rawPointerCoords);
+
+    return reinterpret_cast<jint>(event);
+
+Error:
+    if (!nativePtr) {
+        delete event;
+    }
+    return 0;
+}*/
+
 static jint android_view_MotionEvent_nativeCopy(JNIEnv* env, jclass clazz,
         jint destNativePtr, jint sourceNativePtr, jboolean keepHistory) {
     MotionEvent* destEvent = reinterpret_cast<MotionEvent*>(destNativePtr);
@@ -453,6 +507,22 @@
     return event->getAction();
 }
 
+// ADDED BY JH
+/*static jint android_view_MotionEvent_nativeGetSourceDevice(JNIEnv* env, jclass clazz,
+        jint nativePtr) {
+    MotionEvent* event = reinterpret_cast<MotionEvent*>(nativePtr);
+    ALOGD("JNIsourceDevice-get: %d", event->getSourceDevice());
+    return event->getSourceDevice();
+}
+
+static void android_view_MotionEvent_nativeSetSourceDevice(JNIEnv* env, jclass clazz,
+        jint nativePtr, jint sourceDevice) {
+    MotionEvent* event = reinterpret_cast<MotionEvent*>(nativePtr);
+    event->setSourceDevice(sourceDevice);
+    ALOGD("JNIsourceDevice-set: %d", sourceDevice);
+}*/
+// ADDED BY JH
+
 static void android_view_MotionEvent_nativeSetAction(JNIEnv* env, jclass clazz,
         jint nativePtr, jint action) {
     MotionEvent* event = reinterpret_cast<MotionEvent*>(nativePtr);
@@ -732,6 +802,10 @@
             "(IIIIIIIIFFFFJJI[Landroid/view/MotionEvent$PointerProperties;"
                     "[Landroid/view/MotionEvent$PointerCoords;)I",
             (void*)android_view_MotionEvent_nativeInitialize },
+	/*{ "nativeInitialize",
+			"(IIIIIIIIIFFFFJJI[Landroid/view/MotionEvent$PointerProperties;"
+					"[Landroid/view/MotionEvent$PointerCoords;)I",
+			(void*)android_view_MotionEvent_nativeInitialize },*/
     { "nativeCopy",
             "(IIZ)I",
             (void*)android_view_MotionEvent_nativeCopy },
@@ -750,6 +824,12 @@
     { "nativeSetSource",
             "(II)I",
             (void*)android_view_MotionEvent_nativeSetSource },
+/*	{ "nativeGetSourceDevice",
+			"(I)I",
+			(void*)android_view_MotionEvent_nativeGetSourceDevice },
+	{ "nativeSetSourceDevice",
+			"(II)V",
+			(void*)android_view_MotionEvent_nativeSetSourceDevice },*/
     { "nativeGetAction",
             "(I)I",
             (void*)android_view_MotionEvent_nativeGetAction },
diff -urN Original_4.4.4_r1/frameworks/base/location/java/android/location/ILocationManager.aidl AndroidSource/frameworks/base/location/java/android/location/ILocationManager.aidl
--- Original_4.4.4_r1/frameworks/base/location/java/android/location/ILocationManager.aidl	2016-01-29 15:12:31.431488000 +0900
+++ AndroidSource/frameworks/base/location/java/android/location/ILocationManager.aidl	2015-08-17 19:25:51.000000000 +0900
@@ -76,6 +76,9 @@
     void clearTestProviderEnabled(String provider);
     void setTestProviderStatus(String provider, int status, in Bundle extras, long updateTime);
     void clearTestProviderStatus(String provider);
+    
+    // ADDED BY JH
+    void setRemoteProviderEnabled(boolean enabled);
 
     boolean sendExtraCommand(String provider, String command, inout Bundle extras);
 
